Subject: bug#36463: jupyter terminal out of pty devices

From: Steffen Rytter Postas <[email-masked]>
Date: Sat, 6 Jul 2019 01:49:54 +0200

Hi Ludo,

I can confirm that commit 935e79af61f4d903e562362cdd828be807e15581 does
indeed resolve the issue entirely. Thank you so much for the quick
response and action!

Den 06/07/2019 kl. 00.28 skrev Ludovic Courtès:
> Hello,
>
> Steffen Rytter Postas <[email-masked]> skribis:
>
>> Both environments use the same command to execute, and are using `guix
>> environment` to start the Jupyter notebook system:
>>
>> `LC_ALL=C guix environment -C -N --pure -m env.scm -- jupyter-notebook`
>>
>> The `env.scm` file used, is as follows:
>>
>>
>> (define-packages '(
>>     "glibc-utf8-locales"
>>     "coreutils-minimal"
>>     "bash"
>>     "python"
>>     "jupyter"
>>     ))
>> (use-modules (gnu packages))
>> (packages->manifest (map specification->package packages))
> Without ‘-C’, the Jupyter terminal is indeed working for me:
>
>   guix environment --ad-hoc jupyter python-ipython python-ipykernel \
>      bash coreutils --pure -- jupyter notebook
>
> (Though for some reason IceCat displays white boxes instead of the
> actual characters in the terminal, unless I zoom in or out.  But that’s
> another problem…)
>
>> "/gnu/store/h8l1pby3cm6b4fxsfwwr65b4d1hyh6cs-python-3.7.0/lib/python3.7/pty.py",
>> line 96, in fork
>>         master_fd, slave_fd = openpty()
>>       File
>> "/gnu/store/h8l1pby3cm6b4fxsfwwr65b4d1hyh6cs-python-3.7.0/lib/python3.7/pty.py",
>> line 29, in openpty
>>         master_fd, slave_name = _open_terminal()
>>       File
>> "/gnu/store/h8l1pby3cm6b4fxsfwwr65b4d1hyh6cs-python-3.7.0/lib/python3.7/pty.py",
>> line 59, in _open_terminal
>>         raise OSError('out of pty devices')
>>     OSError: out of pty devices
>> [W 18:56:52.377 NotebookApp] Unhandled error
>>
>> So it seems that there's an issue with pty devices when running these
>> systems as a container.
> I could reproduce the problem, and AFAICS commit
> 935e79af61f4d903e562362cdd828be807e15581 fixes it.
>
> Let me know if it’s all fine now!
>
> Thanks,
> Ludo’.
>